diff --git a/third_party/rust/regex/tests/crazy.rs b/third_party/rust/regex/tests/crazy.rs
index ade839ade134..6fc4980ebc46 100644
--- a/third_party/rust/regex/tests/crazy.rs
+++ b/third_party/rust/regex/tests/crazy.rs
@@ -42,16 +42,43 @@ mat!(negclass_letters, r"[^ac]", "acx", Some((2, 3)));
 mat!(negclass_letter_comma, r"[^a,]", "a,x", Some((2, 3)));
 mat!(negclass_letter_space, r"[^a\s]", "a x", Some((2, 3)));
 mat!(negclass_comma, r"[^,]", ",,x", Some((2, 3)));
 mat!(negclass_space, r"[^\s]", " a", Some((1, 2)));
 mat!(negclass_space_comma, r"[^,\s]", ", a", Some((2, 3)));
 mat!(negclass_comma_space, r"[^\s,]", " ,a", Some((2, 3)));
 mat!(negclass_ascii, r"[^[:alpha:]Z]", "A1", Some((1, 2)));
 
+// Test that repeated empty expressions don't loop forever.
+mat!(lazy_many_many, r"((?:.*)*?)=", "a=b", Some((0, 2)));
+mat!(lazy_many_optional, r"((?:.?)*?)=", "a=b", Some((0, 2)));
+mat!(lazy_one_many_many, r"((?:.*)+?)=", "a=b", Some((0, 2)));
+mat!(lazy_one_many_optional, r"((?:.?)+?)=", "a=b", Some((0, 2)));
+mat!(lazy_range_min_many, r"((?:.*){1,}?)=", "a=b", Some((0, 2)));
+mat!(lazy_range_many, r"((?:.*){1,2}?)=", "a=b", Some((0, 2)));
+mat!(greedy_many_many, r"((?:.*)*)=", "a=b", Some((0, 2)));
+mat!(greedy_many_optional, r"((?:.?)*)=", "a=b", Some((0, 2)));
+mat!(greedy_one_many_many, r"((?:.*)+)=", "a=b", Some((0, 2)));
+mat!(greedy_one_many_optional, r"((?:.?)+)=", "a=b", Some((0, 2)));
+mat!(greedy_range_min_many, r"((?:.*){1,})=", "a=b", Some((0, 2)));
+mat!(greedy_range_many, r"((?:.*){1,2})=", "a=b", Some((0, 2)));
+
+// Test that we handle various flavors of empty expressions.
+matiter!(match_empty1, r"", "", (0, 0));
+matiter!(match_empty2, r"", "abc", (0, 0), (1, 1), (2, 2), (3, 3));
+matiter!(match_empty3, r"()", "abc", (0, 0), (1, 1), (2, 2), (3, 3));
+matiter!(match_empty4, r"()*", "abc", (0, 0), (1, 1), (2, 2), (3, 3));
+matiter!(match_empty5, r"()+", "abc", (0, 0), (1, 1), (2, 2), (3, 3));
+matiter!(match_empty6, r"()?", "abc", (0, 0), (1, 1), (2, 2), (3, 3));
+matiter!(match_empty7, r"()()", "abc", (0, 0), (1, 1), (2, 2), (3, 3));
+matiter!(match_empty8, r"()+|z", "abc", (0, 0), (1, 1), (2, 2), (3, 3));
+matiter!(match_empty9, r"z|()+", "abc", (0, 0), (1, 1), (2, 2), (3, 3));
+matiter!(match_empty10, r"()+|b", "abc", (0, 0), (1, 1), (2, 2), (3, 3));
+matiter!(match_empty11, r"b|()+", "abc", (0, 0), (1, 2), (3, 3));
+
 // Test that the DFA can handle pathological cases.
 // (This should result in the DFA's cache being flushed too frequently, which
 // should cause it to quit and fall back to the NFA algorithm.)
 #[test]
 fn dfa_handles_pathological_case() {
     fn ones_and_zeroes(count: usize) -> String {
         use rand::{Rng, thread_rng};
 
@@ -71,8 +98,304 @@ fn dfa_handles_pathological_case() {
     let text = {
         let mut pieces = ones_and_zeroes(100_000);
         pieces.push('1');
         pieces.push_str(&ones_and_zeroes(20));
         pieces
     };
     assert!(re.is_match(text!(&*text)));
 }
+
+#[test]
+fn nest_limit_makes_it_parse() {
+    use regex::RegexBuilder;
+
+    RegexBuilder::new(
+        r#"
+        2(?:
+          [45]\d{3}|
+          7(?:
+            1[0-267]|
+            2[0-289]|
+            3[0-29]|
+            4[01]|
+            5[1-3]|
+            6[013]|
+            7[0178]|
+            91
+          )|
+          8(?:
+            0[125]|
+            [139][1-6]|
+            2[0157-9]|
+            41|
+            6[1-35]|
+            7[1-5]|
+            8[1-8]|
+            90
+          )|
+          9(?:
+            0[0-2]|
+            1[0-4]|
+            2[568]|
+            3[3-6]|
+            5[5-7]|
+            6[0167]|
+            7[15]|
+            8[0146-9]
+          )
+        )\d{4}|
+        3(?:
+          12?[5-7]\d{2}|
+          0(?:
+            2(?:
+              [025-79]\d|
+              [348]\d{1,2}
+            )|
+            3(?:
+              [2-4]\d|
+              [56]\d?
+            )
+          )|
+          2(?:
+            1\d{2}|
+            2(?:
+              [12]\d|
+              [35]\d{1,2}|
+              4\d?
+            )
+          )|
+          3(?:
+            1\d{2}|
+            2(?:
+              [2356]\d|
+              4\d{1,2}
+            )
+          )|
+          4(?:
+            1\d{2}|
+            2(?:
+              2\d{1,2}|
+              [47]|
+              5\d{2}
+            )
+          )|
+          5(?:
+            1\d{2}|
+            29
+          )|
+          [67]1\d{2}|
+          8(?:
+            1\d{2}|
+            2(?:
+              2\d{2}|
+              3|
+              4\d
+            )
+          )
+        )\d{3}|
+        4(?:
+          0(?:
+            2(?:
+              [09]\d|
+              7
+            )|
+            33\d{2}
+          )|
+          1\d{3}|
+          2(?:
+            1\d{2}|
+            2(?:
+              [25]\d?|
+              [348]\d|
+              [67]\d{1,2}
+            )
+          )|
+          3(?:
+            1\d{2}(?:
+              \d{2}
+            )?|
+            2(?:
+              [045]\d|
+              [236-9]\d{1,2}
+            )|
+            32\d{2}
+          )|
+          4(?:
+            [18]\d{2}|
+            2(?:
+              [2-46]\d{2}|
+              3
+            )|
+            5[25]\d{2}
+          )|
+          5(?:
+            1\d{2}|
+            2(?:
+              3\d|
+              5
+            )
+          )|
+          6(?:
+            [18]\d{2}|
+            2(?:
+              3(?:
+                \d{2}
+              )?|
+              [46]\d{1,2}|
+              5\d{2}|
+              7\d
+            )|
+            5(?:
+              3\d?|
+              4\d|
+              [57]\d{1,2}|
+              6\d{2}|
+              8
+            )
+          )|
+          71\d{2}|
+          8(?:
+            [18]\d{2}|
+            23\d{2}|
+            54\d{2}
+          )|
+          9(?:
+            [18]\d{2}|
+            2[2-5]\d{2}|
+            53\d{1,2}
+          )
+        )\d{3}|
+        5(?:
+          02[03489]\d{2}|
+          1\d{2}|
+          2(?:
+            1\d{2}|
+            2(?:
+              2(?:
+                \d{2}
+              )?|
+              [457]\d{2}
+            )
+          )|
+          3(?:
+            1\d{2}|
+            2(?:
+              [37](?:
+                \d{2}
+              )?|
+              [569]\d{2}
+            )
+          )|
+          4(?:
+            1\d{2}|
+            2[46]\d{2}
+          )|
+          5(?:
+            1\d{2}|
+            26\d{1,2}
+          )|
+          6(?:
+            [18]\d{2}|
+            2|
+            53\d{2}
+          )|
+          7(?:
+            1|
+            24
+          )\d{2}|
+          8(?:
+            1|
+            26
+          )\d{2}|
+          91\d{2}
+        )\d{3}|
+        6(?:
+          0(?:
+            1\d{2}|
+            2(?:
+              3\d{2}|
+              4\d{1,2}
+            )
+          )|
+          2(?:
+            2[2-5]\d{2}|
+            5(?:
+              [3-5]\d{2}|
+              7
+            )|
+            8\d{2}
+          )|
+          3(?:
+            1|
+            2[3478]
+          )\d{2}|
+          4(?:
+            1|
+            2[34]
+          )\d{2}|
+          5(?:
+            1|
+            2[47]
+          )\d{2}|
+          6(?:
+            [18]\d{2}|
+            6(?:
+              2(?:
+                2\d|
+                [34]\d{2}
+              )|
+              5(?:
+                [24]\d{2}|
+                3\d|
+                5\d{1,2}
+              )
+            )
+          )|
+          72[2-5]\d{2}|
+          8(?:
+            1\d{2}|
+            2[2-5]\d{2}
+          )|
+          9(?:
+            1\d{2}|
+            2[2-6]\d{2}
+          )
+        )\d{3}|
+        7(?:
+          (?:
+            02|
+            [3-589]1|
+            6[12]|
+            72[24]
+          )\d{2}|
+          21\d{3}|
+          32
+        )\d{3}|
+        8(?:
+          (?:
+            4[12]|
+            [5-7]2|
+            1\d?
+          )|
+          (?:
+            0|
+            3[12]|
+            [5-7]1|
+            217
+          )\d
+        )\d{4}|
+        9(?:
+          [35]1|
+          (?:
+            [024]2|
+            81
+          )\d|
+          (?:
+            1|
+            [24]1
+          )\d{2}
+        )\d{3}
+        "#
+    )
+    .build()
+    .unwrap();
+}
diff --git a/third_party/rust/regex/tests/macros.rs b/third_party/rust/regex/tests/macros.rs
index 2cd1463b4e27..3c4b888b2013 100644
--- a/third_party/rust/regex/tests/macros.rs
+++ b/third_party/rust/regex/tests/macros.rs
@@ -9,17 +9,17 @@ macro_rules! findall {
 
 // Macros for automatically producing tests.
 
 macro_rules! ismatch {
     ($name:ident, $re:expr, $text:expr, $ismatch:expr) => {
         #[test]
         fn $name() {
             let re = regex!($re);
-            assert!($ismatch == re.is_match(text!($text)));
+            assert_eq!($ismatch, re.is_match(text!($text)));
         }
     };
 }
 
 macro_rules! mat(
     ($name:ident, $re:expr, $text:expr, $($loc:tt)+) => (
         #[test]
         fn $name() {
diff --git a/third_party/rust/regex/tests/macros_bytes.rs b/third_party/rust/regex/tests/macros_bytes.rs
index 4a382c78dd9f..7605d69b21be 100644
--- a/third_party/rust/regex/tests/macros_bytes.rs
+++ b/third_party/rust/regex/tests/macros_bytes.rs
@@ -1,17 +1,15 @@
 // Macros for use in writing tests generic over &str/&[u8].
 macro_rules! text { ($text:expr) => { $text.as_bytes() } }
 macro_rules! t { ($re:expr) => { text!($re) } }
 macro_rules! match_text { ($text:expr) => { $text.as_bytes() } }
+macro_rules! use_ { ($($path: tt)*) => { use regex::bytes::$($path)*; } }
 
 macro_rules! bytes { ($text:expr) => { $text } }
-macro_rules! b { ($text:expr) => { bytes!($text) } }
-
-// macro_rules! u { ($re:expr) => { concat!("(?u)", $re) } }
 
 macro_rules! no_expand {
     ($text:expr) => {{
         use regex::bytes::NoExpand;
         NoExpand(text!($text))
     }}
 }
 
diff --git a/third_party/rust/regex/tests/macros_str.rs b/third_party/rust/regex/tests/macros_str.rs
index e5b0e219daa9..fda5814b8ca8 100644
--- a/third_party/rust/regex/tests/macros_str.rs
+++ b/third_party/rust/regex/tests/macros_str.rs
@@ -1,17 +1,13 @@
 // Macros for use in writing tests generic over &str/&[u8].
 macro_rules! text { ($text:expr) => { $text } }
 macro_rules! t { ($text:expr) => { text!($text) } }
 macro_rules! match_text { ($text:expr) => { $text.as_str() } }
-
-macro_rules! bytes { ($text:expr) => { $text.as_bytes() } }
-macro_rules! b { ($text:expr) => { bytes!($text) } }
-
-// macro_rules! u { ($re:expr) => { $re } }
+macro_rules! use_ { ($($path: tt)*) => { use regex::$($path)*; } }
 
 macro_rules! no_expand {
     ($text:expr) => {{
         use regex::NoExpand;
         NoExpand(text!($text))
     }}
 }
 
diff --git a/third_party/rust/regex/tests/noparse.rs b/third_party/rust/regex/tests/noparse.rs
index ce2d369e2065..62eb5be77e28 100644
--- a/third_party/rust/regex/tests/noparse.rs
+++ b/third_party/rust/regex/tests/noparse.rs
@@ -6,43 +6,45 @@ macro_rules! noparse(
             match regex_new!(re) {
                 Err(_) => {},
                 Ok(_) => panic!("Regex '{}' should cause a parse error.", re),
             }
         }
     );
 );
 
-noparse!(fail_double_repeat, "a**");
 noparse!(fail_no_repeat_arg, "*");
 noparse!(fail_incomplete_escape, "\\");
 noparse!(fail_class_incomplete, "[A-");
 noparse!(fail_class_not_closed, "[A");
 noparse!(fail_class_no_begin, r"[\A]");
 noparse!(fail_class_no_end, r"[\z]");
 noparse!(fail_class_no_boundary, r"[\b]");
 noparse!(fail_open_paren, "(");
 noparse!(fail_close_paren, ")");
 noparse!(fail_invalid_range, "[a-Z]");
 noparse!(fail_empty_capture_name, "(?P<>a)");
-noparse!(fail_empty_capture_exp, "(?P<name>)");
 noparse!(fail_bad_capture_name, "(?P<na-me>)");
 noparse!(fail_bad_flag, "(?a)a");
-noparse!(fail_empty_alt_before, "|a");
-noparse!(fail_empty_alt_after, "a|");
 noparse!(fail_too_big, "a{10000000}");
 noparse!(fail_counted_no_close, "a{1001");
 noparse!(fail_unfinished_cap, "(?");
 noparse!(fail_unfinished_escape, "\\");
 noparse!(fail_octal_digit, r"\8");
 noparse!(fail_hex_digit, r"\xG0");
 noparse!(fail_hex_short, r"\xF");
 noparse!(fail_hex_long_digits, r"\x{fffg}");
 noparse!(fail_flag_bad, "(?a)");
 noparse!(fail_flag_empty, "(?)");
 noparse!(fail_double_neg, "(?-i-i)");
 noparse!(fail_neg_empty, "(?i-)");
-noparse!(fail_empty_group, "()");
 noparse!(fail_dupe_named, "(?P<a>.)(?P<a>.)");
 noparse!(fail_range_end_no_class, "[a-[:lower:]]");
 noparse!(fail_range_end_no_begin, r"[a-\A]");
 noparse!(fail_range_end_no_end, r"[a-\z]");
 noparse!(fail_range_end_no_boundary, r"[a-\b]");
+noparse!(fail_empty_alt1, r"|z");
+noparse!(fail_empty_alt2, r"z|");
+noparse!(fail_empty_alt3, r"|");
+noparse!(fail_empty_alt4, r"||");
+noparse!(fail_empty_alt5, r"()|z");
+noparse!(fail_empty_alt6, r"z|()");
+noparse!(fail_empty_alt7, r"(|)");
diff --git a/third_party/rust/regex/tests/regression.rs b/third_party/rust/regex/tests/regression.rs
index 7a30b1527f12..a09333e2c3ae 100644
--- a/third_party/rust/regex/tests/regression.rs
+++ b/third_party/rust/regex/tests/regression.rs
@@ -56,37 +56,39 @@ split!(split_on_word_boundary, r"\b", r"Should this (work?)",
        &[t!(""), t!("Should"), t!(" "), t!("this"),
          t!(" ("), t!("work"), t!("?)")]);
 matiter!(word_boundary_dfa, r"\b", "a b c",
          (0, 0), (1, 1), (2, 2), (3, 3), (4, 4), (5, 5));
 
 // See: https://github.com/rust-lang/regex/issues/268
 matiter!(partial_anchor, r"^a|b", "ba", (0, 1));
 
-// See: https://github.com/rust-lang/regex/issues/264
-mat!(ascii_boundary_no_capture, r"(?-u)\B", "\u{28f3e}", Some((0, 0)));
-mat!(ascii_boundary_capture, r"(?-u)(\B)", "\u{28f3e}", Some((0, 0)));
-
 // See: https://github.com/rust-lang/regex/issues/280
 ismatch!(partial_anchor_alternate_begin, r"^a|z", "yyyyya", false);
 ismatch!(partial_anchor_alternate_end, r"a$|z", "ayyyyy", false);
 
 // See: https://github.com/rust-lang/regex/issues/289
 mat!(lits_unambiguous1, r"(ABC|CDA|BC)X", "CDAX", Some((0, 4)));
 
 // See: https://github.com/rust-lang/regex/issues/291
 mat!(lits_unambiguous2, r"((IMG|CAM|MG|MB2)_|(DSCN|CIMG))(?P<n>[0-9]+)$",
      "CIMG2341", Some((0, 8)), Some((0, 4)), None, Some((0, 4)), Some((4, 8)));
 
 // See: https://github.com/rust-lang/regex/issues/271
-mat!(end_not_wb, r"$(?-u:\B)", "\u{5c124}\u{b576c}", Some((8, 8)));
 mat!(endl_or_wb, r"(?m:$)|(?-u:\b)", "\u{6084e}", Some((4, 4)));
 mat!(zero_or_end, r"(?i-u:\x00)|$", "\u{e682f}", Some((4, 4)));
 mat!(y_or_endl, r"(?i-u:y)|(?m:$)", "\u{b4331}", Some((4, 4)));
 mat!(wb_start_x, r"(?u:\b)^(?-u:X)", "X", Some((0, 1)));
 
 // See: https://github.com/rust-lang/regex/issues/321
 ismatch!(strange_anchor_non_complete_prefix, r"a^{2}", "", false);
 ismatch!(strange_anchor_non_complete_suffix, r"${2}a", "", false);
 
 // See: https://github.com/rust-lang/regex/issues/334
 mat!(captures_after_dfa_premature_end, r"a(b*(X|$))?", "abcbX",
      Some((0, 1)), None, None);
+
+// See: https://github.com/rust-lang/regex/issues/437
+ismatch!(
+    literal_panic,
+    r"typename type\-parameter\-\d+\-\d+::.+",
+    "test",
+    false);
diff --git a/third_party/rust/regex/tests/replace.rs b/third_party/rust/regex/tests/replace.rs
index 22eb0c5e5791..6d5a5b13b037 100644
--- a/third_party/rust/regex/tests/replace.rs
+++ b/third_party/rust/regex/tests/replace.rs
@@ -28,11 +28,23 @@ replace!(simple_expand, replace_all, r"(\w) (\w)", "a b", t!("$2 $1"), "b a");
 replace!(literal_dollar1, replace_all,
          r"(\w+) (\w+)", "a b", t!("$$1"), "$1");
 replace!(literal_dollar2, replace_all,
          r"(\w+) (\w+)", "a b", t!("$2 $$c $1"), "b $c a");
 replace!(no_expand1, replace,
          r"(\S+)\s+(\S+)", "w1 w2", no_expand!("$2 $1"), "$2 $1");
 replace!(no_expand2, replace,
          r"(\S+)\s+(\S+)", "w1 w2", no_expand!("$$1"), "$$1");
+use_!(Captures);
+replace!(closure_returning_reference, replace, r"(\d+)", "age: 26",
+         | captures: &Captures | &match_text!(captures.get(1).unwrap())[0..1], "age: 2");
+replace!(closure_returning_value, replace, r"\d+", "age: 26",
+         | _captures: &Captures | t!("Z").to_owned(), "age: Z");
+
 
 // See https://github.com/rust-lang/regex/issues/314
 replace!(match_at_start_replace_with_empty, replace_all, r"foo", "foobar", t!(""), "bar");
+
+// See https://github.com/rust-lang/regex/issues/393
+replace!(single_empty_match, replace, r"^", "bar", t!("foo"), "foobar");
+
+// See https://github.com/rust-lang/regex/issues/399
+replace!(capture_longest_possible_name, replace_all, r"(.)", "b", t!("${1}a $1a"), "ba ");
diff --git a/third_party/rust/regex/tests/test_crates_regex.rs b/third_party/rust/regex/tests/test_crates_regex.rs
new file mode 100644
index 000000000000..1f9ce9277abc
--- /dev/null
+++ b/third_party/rust/regex/tests/test_crates_regex.rs
@@ -0,0 +1,57 @@
+extern crate regex;
+extern crate quickcheck;
+
+/*
+ * This test is a minimal version of <rofl_0> and <subdiff_0>
+ *
+ * Once this bug gets fixed, uncomment rofl_0 and subdiff_0
+ * (in `tests/crates_regex.rs`).
+#[test]
+fn word_boundary_backtracking_default_mismatch() {
+    use regex::internal::ExecBuilder;
+
+    let backtrack_re = ExecBuilder::new(r"\b")
+        .bounded_backtracking()
+        .build()
+        .map(|exec| exec.into_regex())
+        .map_err(|err| format!("{}", err))
+        .unwrap();
+
+    let default_re = ExecBuilder::new(r"\b")
+        .build()
+        .map(|exec| exec.into_regex())
+        .map_err(|err| format!("{}", err))
+        .unwrap();
+
+    let input = "䅅\\u{a0}";
+
+    let fi1 = backtrack_re.find_iter(input);
+    let fi2 = default_re.find_iter(input);
+    for (m1, m2) in fi1.zip(fi2) {
+        assert_eq!(m1, m2);
+    }
+}
+*/
+
+mod consistent;
+
+mod crates_regex {
+
+    macro_rules! consistent {
+        ($test_name:ident, $regex_src:expr) => {
+            #[test]
+            fn $test_name() {
+                use super::consistent::backends_are_consistent;
+
+                if option_env!("RUST_REGEX_RANDOM_TEST").is_some() {
+                    match backends_are_consistent($regex_src) {
+                        Ok(_) => {},
+                        Err(err) => panic!("{}", err),
+                    }
+                }
+            }
+        }
+    }
+
+    include!("crates_regex.rs");
+}
diff --git a/third_party/rust/regex/tests/test_default.rs b/third_party/rust/regex/tests/test_default.rs
index e6cf92fa2e66..0f8a0c2dbadc 100644
--- a/third_party/rust/regex/tests/test_default.rs
+++ b/third_party/rust/regex/tests/test_default.rs
@@ -70,8 +70,18 @@ mod word_boundary_unicode;
 
 #[test]
 fn disallow_non_utf8() {
     assert!(regex::Regex::new(r"(?-u)\xFF").is_err());
     assert!(regex::Regex::new(r"(?-u).").is_err());
     assert!(regex::Regex::new(r"(?-u)[\xFF]").is_err());
     assert!(regex::Regex::new(r"(?-u)☃").is_err());
 }
+
+#[test]
+fn disallow_octal() {
+    assert!(regex::Regex::new(r"\0").is_err());
+}
+
+#[test]
+fn allow_octal() {
+    assert!(regex::RegexBuilder::new(r"\0").octal(true).build().is_ok());
+}
diff --git a/third_party/rust/regex/tests/test_default_bytes.rs b/third_party/rust/regex/tests/test_default_bytes.rs
index b049b3d2aaf5..3ac3ce457f5b 100644
--- a/third_party/rust/regex/tests/test_default_bytes.rs
+++ b/third_party/rust/regex/tests/test_default_bytes.rs
@@ -38,17 +38,17 @@ macro_rules! regex_set {
 }
 
 // Must come before other module definitions.
 include!("macros_bytes.rs");
 include!("macros.rs");
 
 // A silly wrapper to make it possible to write and match raw bytes.
 struct R<'a>(&'a [u8]);
-impl<'a> R<'a> { fn as_bytes(&self) -> &'a [u8] { &self.0 } }
+impl<'a> R<'a> { fn as_bytes(&self) -> &'a [u8] { self.0 } }
 
 // See: https://github.com/rust-lang/regex/issues/321
 //
 // These tests are here because they do not have the same behavior in every
 // regex engine.
 mat!(invalid_utf8_nfa1, r".", R(b"\xD4\xC2\x65\x2B\x0E\xFE"), Some((2, 3)));
 mat!(invalid_utf8_nfa2, r"${2}ä", R(b"\xD4\xC2\x65\x2B\x0E\xFE"), None);
 mat!(invalid_utf8_nfa3, r".", R(b"\x0A\xDB\x82\x6E\x33\x01\xDD\x33\xCD"),
diff --git a/third_party/rust/regex/tests/unicode.rs b/third_party/rust/regex/tests/unicode.rs
index 48e9a95aaf41..9b65bc2b5c7f 100644
--- a/third_party/rust/regex/tests/unicode.rs
+++ b/third_party/rust/regex/tests/unicode.rs
@@ -24,8 +24,87 @@ mat!(uni_perl_s, r"\s+", " ", Some((0, 3)));
 mat!(uni_perl_s_not, r"\s+", "☃", None);
 mat!(uni_perl_s_neg, r"\S+", "☃", Some((0, 3)));
 
 // And do the same for word boundaries.
 mat!(uni_boundary_none, r"\d\b", "6δ", None);
 mat!(uni_boundary_ogham, r"\d\b", "6 ", Some((0, 1)));
 mat!(uni_not_boundary_none, r"\d\B", "6δ", Some((0, 1)));
 mat!(uni_not_boundary_ogham, r"\d\B", "6 ", None);
+
+// Test general categories.
+//
+// We should test more, but there's a lot. Write a script to generate more of
+// these tests.
+mat!(uni_class_gencat_cased_letter,
+     r"\p{Cased_Letter}", "Ａ", Some((0, 3)));
+mat!(uni_class_gencat_close_punctuation,
+     r"\p{Close_Punctuation}", "❯", Some((0, 3)));
+mat!(uni_class_gencat_connector_punctuation,
+     r"\p{Connector_Punctuation}", "⁀", Some((0, 3)));
+mat!(uni_class_gencat_control,
+     r"\p{Control}", "\u{9f}", Some((0, 2)));
+mat!(uni_class_gencat_currency_symbol,
+     r"\p{Currency_Symbol}", "￡", Some((0, 3)));
+mat!(uni_class_gencat_dash_punctuation,
+     r"\p{Dash_Punctuation}", "〰", Some((0, 3)));
+mat!(uni_class_gencat_decimal_numer,
+     r"\p{Decimal_Number}", "𑓙", Some((0, 4)));
+mat!(uni_class_gencat_enclosing_mark,
+     r"\p{Enclosing_Mark}", "\u{A672}", Some((0, 3)));
+mat!(uni_class_gencat_final_punctuation,
+     r"\p{Final_Punctuation}", "⸡", Some((0, 3)));
+mat!(uni_class_gencat_format,
+     r"\p{Format}", "\u{E007F}", Some((0, 4)));
+mat!(uni_class_gencat_initial_punctuation,
+     r"\p{Initial_Punctuation}", "⸜", Some((0, 3)));
+mat!(uni_class_gencat_letter,
+     r"\p{Letter}", "Έ", Some((0, 2)));
+mat!(uni_class_gencat_letter_number,
+     r"\p{Letter_Number}", "ↂ", Some((0, 3)));
+mat!(uni_class_gencat_line_separator,
+     r"\p{Line_Separator}", "\u{2028}", Some((0, 3)));
+mat!(uni_class_gencat_lowercase_letter,
+     r"\p{Lowercase_Letter}", "ϛ", Some((0, 2)));
+mat!(uni_class_gencat_mark,
+     r"\p{Mark}", "\u{E01EF}", Some((0, 4)));
+mat!(uni_class_gencat_math,
+     r"\p{Math}", "⋿", Some((0, 3)));
+mat!(uni_class_gencat_modifier_letter,
+     r"\p{Modifier_Letter}", "𖭃", Some((0, 4)));
+mat!(uni_class_gencat_modifier_symbol,
+     r"\p{Modifier_Symbol}", "🏿", Some((0, 4)));
+mat!(uni_class_gencat_nonspacing_mark,
+     r"\p{Nonspacing_Mark}", "\u{1E94A}", Some((0, 4)));
+mat!(uni_class_gencat_number,
+     r"\p{Number}", "⓿", Some((0, 3)));
+mat!(uni_class_gencat_open_punctuation,
+     r"\p{Open_Punctuation}", "｟", Some((0, 3)));
+mat!(uni_class_gencat_other,
+     r"\p{Other}", "\u{bc9}", Some((0, 3)));
+mat!(uni_class_gencat_other_letter,
+     r"\p{Other_Letter}", "ꓷ", Some((0, 3)));
+mat!(uni_class_gencat_other_number,
+     r"\p{Other_Number}", "㉏", Some((0, 3)));
+mat!(uni_class_gencat_other_punctuation,
+     r"\p{Other_Punctuation}", "𞥞", Some((0, 4)));
+mat!(uni_class_gencat_other_symbol,
+     r"\p{Other_Symbol}", "⅌", Some((0, 3)));
+mat!(uni_class_gencat_paragraph_separator,
+     r"\p{Paragraph_Separator}", "\u{2029}", Some((0, 3)));
+mat!(uni_class_gencat_private_use,
+     r"\p{Private_Use}", "\u{10FFFD}", Some((0, 4)));
+mat!(uni_class_gencat_punctuation,
+     r"\p{Punctuation}", "𑁍", Some((0, 4)));
+mat!(uni_class_gencat_separator,
+     r"\p{Separator}", "\u{3000}", Some((0, 3)));
+mat!(uni_class_gencat_space_separator,
+     r"\p{Space_Separator}", "\u{205F}", Some((0, 3)));
+mat!(uni_class_gencat_spacing_mark,
+     r"\p{Spacing_Mark}", "\u{16F7E}", Some((0, 4)));
+mat!(uni_class_gencat_symbol,
+     r"\p{Symbol}", "⯈", Some((0, 3)));
+mat!(uni_class_gencat_titlecase_letter,
+     r"\p{Titlecase_Letter}", "ῼ", Some((0, 3)));
+mat!(uni_class_gencat_unassigned,
+     r"\p{Unassigned}", "\u{10FFFF}", Some((0, 4)));
+mat!(uni_class_gencat_uppercase_letter,
+     r"\p{Uppercase_Letter}", "Ꝋ", Some((0, 3)));
diff --git a/third_party/rust/regex/tests/word_boundary_unicode.rs b/third_party/rust/regex/tests/word_boundary_unicode.rs
index 43612a91ac68..c41355ffc4b8 100644
--- a/third_party/rust/regex/tests/word_boundary_unicode.rs
+++ b/third_party/rust/regex/tests/word_boundary_unicode.rs
@@ -1,8 +1,6 @@
 // Unicode word boundaries know about Unicode characters.
 // For ASCII word boundaries, the tests are precisely inverted.
 matiter!(unicode1, r"\bx\b", "áxβ");
 matiter!(unicode2, r"\Bx\B", "áxβ", (2, 3));
 
 matiter!(ascii1, r"(?-u:\b)x(?-u:\b)", "áxβ", (2, 3));
-matiter!(ascii2, r"(?-u:\B)x(?-u:\B)", "áxβ");
-matiter!(ascii3, r"(?-u:\B)", "0\u{7EF5E}", (5, 5));
diff --git a/third_party/rust/smallvec/Cargo.toml b/third_party/rust/smallvec/Cargo.toml
index 02191cb84be1..4600cdbd4ebe 100644
--- a/third_party/rust/smallvec/Cargo.toml
+++ b/third_party/rust/smallvec/Cargo.toml
@@ -7,30 +7,34 @@
 #
 # If you believe there's an error in this file please file an
 # issue against the rust-lang/cargo repository. If you're
 # editing this file be aware that the upstream Cargo.toml
 # will likely look very different (and much more reasonable)
 
 [package]
 name = "smallvec"
-version = "0.6.0"
+version = "0.6.5"
 authors = ["Simon Sapin <simon.sapin@exyr.org>"]
 description = "'Small vector' optimization: store up to a small number of items on the stack"
 documentation = "http://doc.servo.org/smallvec/"
 readme = "README.md"
 keywords = ["small", "vec", "vector", "stack", "no_std"]
 categories = ["data-structures"]
-license = "MPL-2.0"
+license = "MIT/Apache-2.0"
 repository = "https://github.com/servo/rust-smallvec"
 
 [lib]
 name = "smallvec"
 path = "lib.rs"
 [dependencies.serde]
 version = "1"
 optional = true
+
+[dependencies.unreachable]
+version = "1.0.0"
 [dev-dependencies.bincode]
-version = "0.8"
+version = "1.0.1"
 
 [features]
 default = ["std"]
 std = []
+union = []
